package Plugins::DB;
use strict;
# database interface plugin
# $Version$
# handles reading, writing and searching the database
use DBI;
our $dbh;

sub new {
	my $class = shift;
	my $host = shift;
	my $base = shift;
	my $user = shift;
	my $pass = shift;

	$dbh = DBI->connect("DBI:mysql:database=$base;host=$host",$user,$pass,{PrintError => 1});

	# that's unpolite, I know
	die $dbh->errstr unless $dbh;
	
	my $self = {
	# that's what we use to send messages
		dbh => $dbh,
	};

	bless $self, $class;
}

sub new_records {
	my $self = shift;
	my $count = shift;

	if ( ($count < 1) || ($count > 40) )
	{
		$count = 20;
	};

	my $sth = $self->{'dbh'}->prepare("SELECT term FROM terms ORDER BY changed DESC LIMIT $count");
	$sth->execute();
	my $rows = $sth->rows(); # how many answers?
	my @res = ();
	my $ref;
	my $tcounter = 0;
	for (my $i = 1; $i <= $rows; $i++)
	{
			$tcounter++;
			$ref = $sth->fetchrow_hashref();
			push @res,$ref->{'term'};
	};
	return ($tcounter,join(", ",@res));
}

# performs database lookup for a keyword
sub look_up_term {
	my $self = shift;
	my $arg = shift;
	# nothing was asked, return nothing
	return unless($arg);

	my ($row,$query,$sth);

	$arg = &_quote($arg);

	$query = "SELECT story FROM terms WHERE term='$arg'";
	$sth = $self->{'dbh'}->prepare($query);
	$sth->execute();	
	$row = $sth->fetchrow_hashref();

	# if record was found increase the counter
	if ($row)
	{
		$query = "UPDATE terms SET counter = counter + 1 WHERE term = '$arg'";
		$sth = $self->{'dbh'}->prepare($query);
		$sth->execute();
	}
	else
	{
		$row->{'story'} = "";
	};
	return $row->{'story'};
};

sub _quote {
	my $arg = shift;
	$arg =~ s/'/\\'/g;
	return $arg;
};



1;
