package Dict;
# database interface plugin
# $Header: /cvsroot/tuxaator/tuxaator/Plugins/Dict/Plugin.pm,v 1.15 2004/11/08 22:05:49 duke9 Exp $
use strict;
use DBI;

sub new
{
	my $class = shift;
	my $core = shift;
	my $self =
	{
		core => $core,
	};
	bless $self, $class;
};

sub get_id
{
	my $class = shift;
	return "Dict";
};

sub get_msg_handlers
{
	my $class = shift;
	return (
		"!new" =>
		{
			"action"	=> "do_new",
			"restricted"	=> 0,
		},
		
		"??" =>
	 	{
			"action"	=> "do_query",
			"restricted"	=> 0,
		},
		
	 	"?" =>
	 	{
			"action"	=> "do_query",
			"restricted"	=> 0,
		},
		
		"!learn" =>
		{
			"action"	=> "do_learn",
			"restricted"	=> 1,
		 	"level"		=> 2,
		},

		"!forget" =>
		{
			"action"	=> "do_forget",
			"restricted" 	=> 1,
			"level" 	=> 2,
			#"status" 	=> "o"
			#"status" 	=> "v"
			#"regnick"	=> 1
		},

		"!add" =>
		{
			"action"	=> "do_add",
			"restricted"	=> 1,
			"level" 	=> 2,
		},

		"!brainwash" =>
		{
			"action"	=> "do_brainwash",
			"restricted"	=> 1,
			"level"		=> 2,
		},
	
		"!apropos" =>
		{
			"action"	=> "do_apropos",
			"restricted" 	=> 0,
		},

		"!?" =>
		{
			"action"	=> "do_apropos",
			"restricted"	=> 0,
		},
	
		"!status" =>
		{
			"action"	=> "do_status",
			"restricted"	=> 1,
			"level"		=> 2,
		},

		"!stats" =>
		{
			"action"	=> "do_term_count",
			"restricted"	=> 0,
		},

		"!history" =>
		{
			"action"	=> "do_history",
			"restricted"	=> 1,
			"level"		=> 2,
		},
		
		"!random" =>
		{
			"action"	=> "do_random",
		},
	);

};

# counts all the terms
sub do_term_count
{
	my $self = shift;
	my $event = pop @_;
	my $query = "SELECT DISTINCT term FROM terms";
	my $sth = $self->{'core'}->{'dbh'}->prepare($query);
	$sth->execute();
	if (!$sth) {
		die "Error:" . $self->{'core'}->{'dbh'}->errstr . "\n";
	}
	my $rows = $sth->rows();	
	$self->{'core'}->queue($event,"Andmebaasis on $rows definitsiooni");
	my @loaded_plugins;
	my $cnt = 0;
	while(my($key,$val) = each %{$self->{'core'}->{'plugins'}})
        {
                push @loaded_plugins,$key;
        }
	$self->{'core'}->queue($event,"Laetud pluginad: " . join(", ",sort @loaded_plugins));
};

sub do_new
{
	my $self = shift;
	my $event = pop @_;

	# I want a separate table for history.
	my $sth = $self->{'core'}->{'dbh'}->prepare("SELECT term FROM terms ORDER BY changed DESC LIMIT 30");
	$sth->execute();
	if (!$sth) {
		die "Error:" . $self->{'core'}->{'dbh'}->errstr . "\n";
	}

	# how many answers?
	my $rows = $sth->rows();
	my @terms;
	for (my $i = 1; $i <= $rows; $i++)
	{
		my $ref = $sth->fetchrow_hashref();
		push @terms,$ref->{'term'};
	};
	my $tstr = "30 viimati lisatud/muudetud terminit: " . join(", ",@terms);
	$self->{'core'}->queue($event,join(", ",$tstr));
};

sub do_status
{
	my $self = shift;
	my $event = pop @_;
	my @args = @_;
	my $argstring = join " " => @args;
	my $msg;
	unless(&is_valid_string($argstring))
	{
		$msg = sprintf($self->{'core'}->{'msgs'}->{'keyword_error'},substr($argstring,0,30) . "...");
		$self->{'core'}->queue($event,$msg);
		return;
	}
	my $sth = $self->{'core'}->{'dbh'}->prepare("SELECT * FROM terms WHERE term = ?");
	$sth->execute($argstring);
	if (!$sth) {
		die "Error:" . $self->{'core'}->{'dbh'}->errstr . "\n";
	}
	my $rows = $sth->rows(); # mitu vastust leiti? 
	if ($rows == 1)
	{
		my $ref = $sth->fetchrow_hashref();
		$msg = sprintf($self->{'core'}->{'msgs'}->{'status_line1'},$argstring,$ref->{'id'},$ref->{'counter'});

		if ($ref->{'nick'})
		{
			$msg .= sprintf("\n" . $self->{'core'}->{'msgs'}->{'status_line2'},$ref->{'nick'},$ref->{'userhost'},$ref->{'changed'});
		};
	}
	else
	{
		$msg = sprintf($self->{'core'}->{'msgs'}->{'keyword_not_found'},$argstring);
	};
	$self->{'core'}->queue($event,$msg);
}

# removes a definition from the database
sub do_forget
{
	my ($self,@args) = @_;
	my $event = pop @args;
	my $msg;
	my $term = join " " => @args;
	unless(&is_valid_string($term))
	{
		$msg = sprintf($self->{'core'}->{'msgs'}->{'keyword_error'}, $term);
		$self->{'core'}->queue($event,$msg);
		return;
	};

	$term =~ s/(^\s*?|\s*?$)//g; #strip leading and trailing whitespace

	my $old = &_get_definition($self, $term);
	unless ($old)
	{
		$msg = sprintf($self->{'core'}->{'msgs'}->{'forget_error1'}, $term);
		$self->{'core'}->queue($event,$msg);
		return;
	}

	# we'll keep record of the evil dude who has no respect for history
	# and clear the description string for no apparent reason
	my $story = "";
	my $history = $old->{'history'} + 1;
	my $counter = $old->{'counter'};
	my $userhost = $event->userhost;
	# save the old one
	my $sth = $self->{'core'}->{'dbh'}->prepare("INSERT INTO history (term,story,counter,nick,userhost,changed) SELECT term,story,counter,nick,userhost,changed FROM terms WHERE term = ?");
	$sth->execute($term);
	if (!$sth) {
		die "Error:" . $self->{'core'}->{'dbh'}->errstr . "\n";
	}
	$sth = $self->{'core'}->{'dbh'}->prepare("UPDATE terms SET story='',nick=?,userhost=?,changed=now() WHERE term = ?");
	if ($sth->execute($event->nick,$userhost,$term))
	{
		$sth = $self->{'core'}->{'dbh'}->prepare("INSERT INTO history (term,story,counter,nick,userhost,changed) SELECT term,story,counter,nick,userhost,changed FROM terms WHERE term = ?");
		if ($sth->execute($term))
		{
			$sth = $self->{'core'}->{'dbh'}->prepare("DELETE FROM terms WHERE term = ?");
			$sth->execute($term);
			$msg = sprintf($self->{'core'}->{'msgs'}->{'forget_success'}, $term);
		}
		else
		{
			$msg = sprintf($self->{'core'}->{'msgs'}->{'forget_fail'},"");
		};
	}
	else
	{
		$msg = sprintf($self->{'core'}->{'msgs'}->{'forget_fail'},"");
	};

	$self->{'core'}->queue($event,$msg);
	return;
};

# replaces a definition
sub do_brainwash
{
	my ($self,@args) = @_;
	my $event = pop @args;
	#$Output->set_prefix($event->nick);
	my $argstring = join " " => @args;
	my ($query,$msg,$sth);
	my ($term,$definition) = $argstring =~ /^\s*(.+?)\s*=\s*(.+?)$/;
	my $nick = $event->nick;
	unless (&is_valid_string($term))
	{
		$msg = sprintf($self->{'core'}->{'msgs'}->{'keyword_error'},$term);
		$self->{'core'}->queue($event,$msg);
		return;
	};

	unless (&is_valid_string($definition))
	{
		$msg = sprintf($self->{'core'}->{'msgs'}->{'desc_error'},$definition);
		$self->{'core'}->queue($event,$msg);
		return;
	};

	my $old = &_get_definition($self, $term);
	unless ($old)
	{
		$msg = sprintf($self->{'core'}->{'msgs'}->{'forget_error1'},$term);
		$self->{'core'}->queue($event,$msg);
		return;
	}

	my $history = $old->{'history'} + 1;
	my $counter = $old->{'counter'};
	my $userhost = $event->userhost;
	# put the old value to history database
	$sth = $self->{'core'}->{'dbh'}->prepare("INSERT INTO history (term,story,counter,nick,userhost,changed) SELECT term,story,counter,nick,userhost,changed FROM terms WHERE term = ?");
	$sth->execute($term);
	if (!$sth) {
		die "Error:" . $self->{'core'}->{'dbh'}->errstr . "\n";
	}
	$sth = $self->{'core'}->{'dbh'}->prepare("UPDATE terms SET story = ?,nick = ?,userhost = ?,changed = now() where term = ?");
	if ($sth->execute($definition,$nick,$userhost,$term))
	{
		$msg = sprintf($self->{'core'}->{'msgs'}->{'brainwash_success'},$term);
		$msg = "Uuendatud\n";
	}
	else
	{
		$msg = sprintf($self->{'core'}->{'msgs'}->{'brainwash_fail'},$self->{'core'}->{'dbh'}->{'errstr'});
	};
	$self->{'core'}->queue($event,$msg);
	return;
};

# adds to the end of a definition
sub do_add
{
	my ($self,@args) = @_;
	my $event = pop @args;
	my $argstring = join " " => @args;
	my ($query,$msg,$sth);
	my ($term,$definition) = $argstring =~ /^\s*(.+?)\s*=\s*(.+?)$/;
	my $nick = $event->nick;
	unless (&is_valid_string($term))
	{
		$msg = sprintf($self->{'core'}->{'msgs'}->{'keyword_error'},$term);
		$self->{'core'}->queue($event,$msg);
		return;
	};
	unless (&is_valid_string($definition))
	{
		$msg = sprintf($self->{'core'}->{'msgs'}->{'desc_error'},$definition);
		$self->{'core'}->queue($event,$msg);
		return;
	};

	my $old = &_get_definition($self, $term);
	unless ($old)
	{
		$msg = sprintf($self->{'core'}->{'msgs'}->{'forget_error1'},$term);
		$self->{'core'}->queue($event,$msg);
		return;
	}

	my $story = $old->{'story'};
	$story = $story . " | " . $definition;
	my $history = $old->{'history'} + 1;
	my $counter = $old->{'counter'};
	my $userhost = $event->userhost;
	# put the old value to history database
	$sth = $self->{'core'}->{'dbh'}->prepare("INSERT INTO history (term,story,counter,nick,userhost,changed) SELECT term,story,counter,nick,userhost,changed FROM terms WHERE term = ?");
	$sth->execute($term);
	if (!$sth) {
		die "Error:" . $self->{'core'}->{'dbh'}->errstr . "\n";
	}
	
	$sth = $self->{'core'}->{'dbh'}->prepare("UPDATE terms SET story = ?,nick = ?,userhost = ?,changed = now() where term = ?");

	if ($sth->execute($story,$nick,$userhost,$term))
	{
		$msg = sprintf($self->{'core'}->{'msgs'}->{'brainwash_success'},$term);
	}
	else
	{
		$msg = sprintf($self->{'core'}->{'msgs'}->{'brainwash_fail'},$self->{'core'}->{'dbh'}->{'errstr'});
	};
	$self->{'core'}->queue($event,$msg);
	return;
};
	

sub do_learn
{
	my ($self,@args) = @_;
	my $msg;
	my $event = pop @args;
	my $argstring = join " " => @args;
	# split argstring at the first =
	my ($term,$definition) = $argstring =~ /^\s*(.+?)\s*=\s*(.+?)$/;
	my $sth;
	$term =~ s/\?$//;

	unless ($definition)
	{
		$msg = sprintf($self->{'core'}->{'msgs'}->{'learn_error1'},$event->nick);
		$self->{'core'}->queue($event,$msg);
		return;
	};

	unless (&is_valid_string($term))
	{
		$msg = sprintf($self->{'core'}->{'msgs'}->{'keyword_error'},$term);
		$self->{'core'}->queue($event,$msg);
		return;
	};

	unless (&is_valid_string($definition))
	{
		$msg = sprintf($self->{'core'}->{'msgs'}->{'desc_error'});
		$self->{'core'}->queue($event,$msg);
		return;
	};
	my ($old,$dsc) = $self->look_up_term($term);
	if ($old)
	{
		$self->{'core'}->queue($event,"'" . $term . "' on juba andmebaasis");
		return;
	}

	my $nick = $event->nick;
	my $userhost = $event->userhost;
	# figure out the revision number
	#my $q = "SELECT MAX(history) AS max FROM terms WHERE term = ?";
	#my $sth = $self->{'core'}->{'dbh'}->prepare($q);
	#$sth->execute($term);
	#my $ref = $sth->fetchrow_hashref();
	#my $revision = $ref->{'max'} + 1;

	# I need to retrieve the last version and insert it into the history table
	#$sth = $self->{'core'}->{'dbh'}->prepare("INSERT INTO history (term,story,counter,nick,userhost,changed) SELECT term,story,counter,nick,userhost,changed FROM terms WHERE term = ?");
	#$sth->execute($term);

	$sth = $self->{'core'}->{'dbh'}->prepare("INSERT INTO terms (term,story,nick,userhost,changed) VALUES (?,?,?,?,now())");
	if ($sth->execute($term,$definition,$nick,$userhost))
	{
		$msg = sprintf($self->{'core'}->{'msgs'}->{'learn_success'},$term);
	}
	else
	{
		$msg = sprintf($self->{'core'}->{'msgs'}->{'learn_fail'},"");
	};
	$self->{'core'}->queue($event,"Jtsin meelde: $term");
	return;
};


sub do_query
{
	my $self = shift;
	my $event = pop @_;
	my @params = @_;
	my $pstr = join(" ",@params);
	my $msg;
	if (length($pstr) == 0)
	{
		return;
	};

	if ( (length($pstr) > 40) || (length($pstr) < 2))
	{
		$msg = sprintf($self->{'core'}->{'msgs'}->{'keyword_error2'});
		$self->{'core'}->queue($event,$msg);
		return;
	};

	# do the real magic
	my($term,$def) = $self->look_up_term($pstr);

	if ($def)
	{
		#$def =~ s/\\//g;
		$msg = sprintf("%s - %s",$term,$def);
	}
	else
	{
		$msg = sprintf($self->{'core'}->{'msgs'}->{'keyword_error3'},$pstr);
	};
	$self->{'core'}->queue($event,$msg);
}

# performs a search on the database
sub do_apropos
{
	my $self = shift;
	my $event = pop;
	my @args = @_;
	my ($msg,$ref);
	my $argstring = join " " => @args;
	unless (&is_valid_string($argstring))
	{
		$msg = sprintf($self->{'core'}->{'msgs'}->{'keyword_error2'});
		$self->{'core'}->queue($event,$msg);
		return;
	};
	unless ((length($argstring) > 1) && (length($argstring) <101))
	{
		$msg = sprintf($self->{'core'}->{'msgs'}->{'keyword_error2'});
		$self->{'core'}->queue($event,$msg);
		return;
	};
	my $q = "SELECT term FROM terms WHERE (story LIKE ? OR term LIKE ?) ORDER BY term LIMIT 30";
  	my $sth = $self->{'core'}->{'dbh'}->prepare($q);
	my $i;
	$argstring = "%" . $argstring . "%";
	if ($sth->execute($argstring,$argstring))
	{
		my $rows = $sth->rows(); # how manu matches?
		my @results;
		if ($rows == 0)
		{
			$msg = $self->{'core'}->{'msgs'}->{'apropos_noresults'};
		}
		else
		{
			for ($i = 0; $i < $rows; $i++)
			{
				$ref = $sth->fetchrow_hashref();
				$ref->{'term'} =~ s/\\//g;
				push @results,$ref->{'term'};
			};
			$msg = sprintf($self->{'core'}->{'msgs'}->{'apropos_results'},join(", ",@results));
		};
		$self->{'core'}->queue($event,$msg);
	};
	
}

# performs database lookup for a keyword
sub look_up_term
{
	my $self = shift;
	my $arg = shift;
	print "looking up $arg\n";
	# nothing was asked, return nothing
	return unless($arg);

	my $def = &_get_definition($self,$arg);
	# print "returned from get_definiton with $def\n";
	my $story;
	my $term;
	
	# if record was found increase the counter
	if ($def)
	{
		my $query = "UPDATE terms SET counter = counter + 1 WHERE term = ?";
		my $sth = $self->{'core'}->{'dbh'}->prepare($query);
		$sth->execute($arg);
		if (!$sth) {
			die "Error:" . $self->{'core'}->{'dbh'}->errstr . "\n";
		}
		$story = $def->{'story'};
		$term = $def->{'term'};
	}
	else
	{
		$story = "";
		$term ="";
	};
	return ($term,$story);
};

# performs history lookup on term
sub do_history
{
	my ($self,@args) = @_;
	my $event = pop @args;
	my $argstring = join(" ", @args);
	my $msg;

	# everything up to first = is $term
	my ($term, $revision) = $argstring =~ /^\s*(.+?)\s*=\s*(.+?)$/;

	unless ($revision)
	{
		($term) = $argstring =~ /^\s*(.+?)\s*$/;
	}
	else
	{	# revision must be numeric
		($revision) = $revision =~ /^\s*(\d+?)\s*$/;
	}

	$term =~ s/\?$//;

	# nothing was asked, return nothing
	return unless($term);

	unless(&is_valid_string($term))
	{
		$msg = sprintf($self->{'core'}->{'msgs'}->{'keyword_error'}, $term);
		$self->{'core'}->queue($event, $msg);
		return;
	};

	if ( (length($term) > 40) || (length($term) < 2))
	{
		$msg = sprintf($self->{'core'}->{'msgs'}->{'keyword_error2'});
		$self->{'core'}->queue($event, $msg);
		return;
	}

	print "history of '$term'";
	if ($revision)
	{
		print " (rev $revision)\n";
	}
	else
	{
		print "\n";
	}

	if ($revision)
	{
		my $def = &_get_definition($self, $term, $revision);

		if ($def)
		{
			my $story = $def->{'story'};
			$story =~ s/\\//g;
			$msg = sprintf("%s - %s", $term, $story);
		}
		else
		{
			$msg = sprintf($self->{'core'}->{'msgs'}->{'keyword_error3'}, $term);
		}
	}
	else
	{
		my $sth = $self->{'core'}->{'dbh'}->prepare("SELECT id,nick, changed FROM history WHERE term = ? ORDER BY changed DESC");
		$sth->execute($term);
		if (!$sth) {
			die "Error:" . $self->{'core'}->{'dbh'}->errstr . "\n";
		}
		my $rows = $sth->rows();

		if ($rows < 1)
		{
			$msg = sprintf($self->{'core'}->{'msgs'}->{'keyword_error3'}, $term);
			$self->{'core'}->queue($event, $msg);
			return;
		}

		my @history;
		my $tstr;
		for (my $i = 1; $i <= $rows; $i++)
		{
			my $ref = $sth->fetchrow_hashref();
			$tstr = "[".$ref->{'id'}."] @ ".$ref->{'changed'}." by ".$ref->{'nick'};
			push @history, $tstr;
		};

		$tstr = join(" | ", @history);
		$msg = sprintf("%s - %s", $term, $tstr);
	}

	$self->{'core'}->queue($event, $msg);
};

sub do_random
{
	my ($self,@args) = @_;
	my $event = pop @args;
	my $sth = $self->{'core'}->{'dbh'}->prepare("SELECT term,story FROM terms ORDER BY RAND() LIMIT 1");
	$sth->execute();
	my $ref = $sth->fetchrow_hashref();
	$self->{'core'}->queue($event, sprintf("%s - %s",$ref->{'term'},$ref->{'story'}));
}

# retrieves a definition from the database
sub _get_definition
{
	my $self = shift;
	my $term = shift;
	my $revision = shift;
	my ($sth,$ref);

	my $query = "SELECT * FROM terms WHERE term = ?";

	if ($revision)
	{
		$query .= "AND history=?";
		$sth = $self->{'core'}->{'dbh'}->prepare($query);
		$sth->execute($term,$revision);
		if (!$sth) {
			die "Error:" . $self->{'core'}->{'dbh'}->errstr . "\n";
		}
	}
	else
	{
		$query .= "";
		$sth = $self->{'core'}->{'dbh'}->prepare($query);
		$sth->execute($term);
		if (!$sth) {
			die "Error:" . $self->{'core'}->{'dbh'}->errstr . "\n";
		}
	}

	my $rows = $sth->rows();

	print "$rows resulted in query for $term\n";

	if ($rows == 1)
	{
			$ref = $sth->fetchrow_hashref();
			$ref->{'story'} =~ s/\\//g;
	}
	else
	{
			$ref = 0;
	};

	return $ref;
}

sub is_valid_string
{
	my $string = shift;
	my $i;
	my $is_valid = 1;
	my $clen = 0;
	if (length($string) < 2)
	{
		print "is_valid_string: String oli liiga lhike\n";
		return 0;
	};
	if (length($string) > 700)
	{
		print "is_valid_string: String on liiga pikk\n";
		return 0;
	};
	my $letter;
	foreach $letter (split(//, $string))
	{
		#print "$letter - ";
		if ( $letter =~ m{[A-Za-z_\|\*\'\?&<>\[\]\+%\^\$\\=0-9@\\~\-."!?,:;/() -#]})
		{
			$clen++;
			#print "$clen\n";
		}
		else
		{
			print "Rejected: $letter\n";
		};
	};
	return (length($string) == $clen);
}

1;
