# $Header: /cvsroot/tuxaator/tuxaator/Plugins/FTP-Status/Plugin.pm,v 1.1 2003/08/07 09:36:18 duke9 Exp $
# FTP status plugin
# it was originally written for one specific box besides running the original Tuxaator
# also serves as a FTP mirror for a few popular distributions and this command turned
# out to be a handy to monitor the current status of the ftp server. 
package FTP_Status;
use BotCore;
use vars qw(@ISA);
@ISA = qw(BotCore);

sub new {
	my $class = shift;
	my $core = shift;
	my $self = {
		core => $core,
	};
	bless $self, $class;
}

sub get_id {
	my $class = shift;
	return "FTP_Status";
}

sub get_msg_handlers {
	my $class = shift;
	return (
		"!ftpcount" 	=>
			{"action"  	=> "get_ftpcount",
			"restricted" => 1,
			"level" => 2},
	);

};

sub get_ftpcount {
	my $self = shift;
	my $event = pop @_;
	my $msg;
	my $max = `grep max_clients /etc/vsftpd.conf | sed -e 's/.*=//'`;
	my $count = `ps ax | grep vsftpd | wc -l`;
	$msg = sprintf("ftp kliente ftp.linux.ee's: %d (max: %d)",$count-1,$max);
	$self->{'core'}->queue($event,$msg);
}


1;
