# RSS plugin
package RSS;
use BotCore;
use XML::RSS;
use Text::Iconv;
use Data::Dumper;
use vars qw(@ISA);
@ISA = qw(BotCore);

sub new {
	my $class = shift;
	my $core = shift;
	my $self = {
		Core => $core,
	};
	bless $self, $class;
}

sub get_id {
	my $class = shift;
	return "RSS";
}

sub get_scheduled_handlers {
	my $class = shift;
	return
	{
		"30" => \&do_headlines,
	};
}



sub do_headlines {
	my $self = shift;
        my $file = $self->{'Core'}->{'basedir'} . '/config/rss.tux';
	# I can't get anything else but UTF-8 out of XML::RSS, so I'll play hardball
	my $rss = new XML::RSS (encoding => 'ISO-8859-1');
	my $converter = Text::Iconv->new("UTF-8", "ISO-8859-4");
        my @applist;
	my ($url,$delay,$cachefile,$rcachefile,$fname,$cache_contents);
        open F,"<$file" or return "";

	foreach (<F>)
	{
		unless (/^#/)
		{
			chomp;
			($url,) = split /,/;
			# make up a filename
			$cachefile = $url;
			$cachefile =~ s|http://||g;
			$cachefile =~ s|\W|_|g;

			$rcachefile = $self->{'Core'}->{'basedir'} . '/cache/' . $cachefile;
			$lcachefile = $self->{'Core'}->{'basedir'} . '/cache/' . $cachefile . "-last";

			if (open INFILE,"<$rcachefile")
			{
				$cache_contents = join "",<INFILE>;
				close INFILE;

				my $last = "";
				if (open L,"<$lcachefile")
				{
					$last = join "",<L>;
					chomp $last;
					close L;
				};

				unless (eval "\$rss->parse(\$cache_contents)")
				{
					return 0;
				};

				my @to_show;

				my $channel = $rss->{channel};
				
				foreach my $item ( @{$rss->{items}})
				{   
					$$item{title} =~ s/(^\s*|\s*$)//g;
                			last if ($$item{title} eq $last);
					push @to_show,$$item{title};
				};
				
				$last = ${$rss->{items}}[0]{title};

        			if ($#to_show > -1)
				{
					my $msg = $channel->{title} . ": ";
					$msg .= join "... " => @to_show;
					$msg = $converter->convert($msg);
					$self->{'Core'}->{'connection'}->privmsg($self->{'Core'}->{'config'}->{'channel'},$msg);
				};

				# now I need to write the thing out to the file
				open L,">$lcachefile";
				print L $last;
				close L;
			};
		};
	};
	close F;
	# check every half an hour
	$self->{'Core'}->{'connection'}->schedule(30*60,\&do_headlines);
	return "";

};

1;
