# $Header: /cvsroot/tuxaator/tuxaator/Plugins/Talk/Plugin.pm,v 1.12 2005/04/09 17:19:29 digg Exp $
# Talk plugin, allows trusted users to talk "through" the bots "mouth"
package Talk;
#use base qw(Tuxaator::Plugin);

# Random-path sayings

# Picks and returns a random element of the supplied list
sub random_of (@) {
    $_[int rand @_]
}

# Picks a random path from a {...|...} markuped string
sub random_path ($) {
    my ($set) = @_;
    while ($set =~ s/\{([^{}]*\|[^{}]*)\}/random_of split m[\|], $1/ge) {}
    return $set;
}

# Generates a random string.  Stringpath specifiers are taken from
# the named file; ${foo} in these paths are replaced according to %subst.
sub make_random_string ($%) {
    my ($filename, %subst) = @_;

    # Read the lines
    my $fh;
    open $fh, "<$filename" or die "$filename: open: $!";
    my @lines = <$fh>;
    close $fh;
    chomp for @lines;

    # Pick a random line and a random path from it
    my $result = random_path random_of @lines;

    # Substitute
    $result =~ s/(\${([\w-]+)})/exists $subst{$2} ? $subst{$2} : $1/ge;

    # Return
    return $result;
}

sub new {
	my $class = shift;
	my $core = shift;
	my $self = {
		core => $core,
	};

	#my %config = $class->Tuxaator::Plugin::configure_plugin($class);


	#my %config = configure_plugin($class);

	# see peaks tegelikult dependentsidega toimuma
	#my %config = plugincore->configure_plugin($class);

	print "!!!";
	print $config{'kala'};
	print "!!!\n";

	bless $self, $class;
}

sub get_id {
	my $class = shift;
	return "Talk";
}

sub get_msg_handlers {
	my $class = shift;
	return ( 
		"!say"     =>
			{"action"       => "do_say",
			"restricted"   => 1,
			"level" => 3},
		"!plan"     =>
			{"action"       => "do_plan",
			"restricted"   => 1,
			"level" => 2},
		"!emote"     =>
			{"action"       => "do_emote",
			"restricted"   => 1,
			"level" => 3},
		"!insult"     =>
			{"action"       => "do_insult",
			 "restricted" => 1,
			"level" => 2},
		"!compliment"     =>
			{"action"       => "do_compliment",
			 "restricted" => 0,
			"level" => 0},
	);

};

#sub get_scheduled_handlers {
#	my $class = shift;
#	return
#	{
#		"60" => \&do_whoa,
#	};
#}

# Says something to the channel
sub do_say {
	my $self = shift;
	my $event = pop @_;
	my $msg = join " " => @_;
	# answer goes to the channel, otherwise it doesnt make too much sense
	# but this does not work with multiple channels
	$event->to($self->{'core'}->{'config'}->{'channel'});
	$self->{'core'}->queue($event,$msg);
}

# Emotes something to the channel
sub do_emote {
	my $self = shift;
	my $event = pop @_;
	my $msg = join " " => @_;
	# anwer goes to the channel, otherwise it doesnt make too much sense
	$event->to($self->{'core'}->{'config'}->{'channel'});
	$self->{'core'}->{'connection'}->me($self->{'core'}->{'config'}->{'channel'},$msg);
}

# Business plan generator, inspired from South Park episode with Underpant Gnomes
# Usage: !plan steal underpants
# the bot responds like this
# 1) steal underpants
# 2) ...
# 3) Make profit!
# The third line comes from the text file plaanid.txt in the main directory
# of the program. By default that file contains only business plans in estonian
# language, but you're welcome to replace those with your own.
sub do_plan {
	my $self = shift;
	my $event = pop @_;
	my $msg = join " " => @_;
	# plaanid.txt is in the root directory of the bot, so you can add/edit/remove plans
	# without needing to restart the bot
        my $finale = make_random_string('plaanid.txt',
            msg => $msg, user => $event->nick);
        my $message = "1) $msg\n".
                      "2) ...\n".
                      "3) $finale\n";
	# answer goes to the channel, otherwise it doesnt make too much sense
	$event->to(@{$event->to}[0]);
	$self->{'core'}->queue($event, $message);
}

sub do_insult {
	my $self = shift;
	my $event = pop @_;
	my $victim = join " " => @_;
	if ( (length($victim) == 0) || (length($victim) > 30) )
	{
		$victim = $event->nick;
	};

        my $message = make_random_string('insult.txt',
	    victim => $victim);
	$self->{'core'}->queue($event, $message);
}

sub do_compliment {
	my $self = shift;
	my $event = pop @_;
	my $victim = join " " => @_;
	if ( (length($victim) == 0) || (length($victim) > 30) )
	{
		$victim = $event->nick;
	};

        my $message = make_random_string('compliment.txt',
	    victim => $victim);
	$self->{'core'}->queue($event, $message);
}


# wrapper for a random quote generator, is executed 60 seconds after the bot joins the
# channel and then again every 10-30 minutes
#
# quote is retrieved from an external program whose location is specified in the
# config file - quotegen key
# quotegen=/usr/games/fortune makes the fortune program run every N minutes and display
# the ouput to the channel
sub do_whoa {
	my $self = shift;
	my $prg = $self->{'Core'}->{'config'}->{'quotegen'};
	unless ($prg)
	{
		return;
	};
	unless ( open F,"$prg |")
	{
		return;
	};
	my @flines = <F>;
	close F;
	my $src;
	foreach(@flines) {
		s/^\s+//;
		s/\s+$//;
		$src .= $_ . "\n";
	};
	my($stype,$msg)=split/\t/=>$src;
	$stype =~ s/\s//g;
	my $type = ($stype eq "action") ? "me" : "privmsg";
	$self->{'Core'}->{'connection'}->$type($self->{'Core'}->{'config'}->{'channel'},$msg);
	$tambovi_konstant = sprintf("%d",rand 40);
	my $next = (60*$tambovi_konstant) + 600;
	printf("Next whoa is due in %d seconds!\n",$next);
	$self->{'Core'}->{'connection'}->schedule($next,\&do_whoa);
}

# now . I need to put the configuration for this module into this directory
# and let only this module access it. So how do I do it?

# do I need to include some kind of code at the start of this file?

1;
