package Vera;
use BotCore;
use vars qw(@ISA);
@ISA = qw(BotCore);

# Ask VERA!
# $Header: /cvsroot/tuxaator/tuxaator/Plugins/Vera/Plugin.pm,v 1.5 2005/04/05 19:49:16 digg Exp $

sub new {
	my $class = shift;
	my $core = shift;
	my $self = {core => $core};
	my $vera_info = $self->{core}->{config}->{vera_info};
	print "Parsing $vera_info\n";
	my $fh;
	unless (open $fh, '-|', "zcat $vera_info") {
		print STDERR "$vera_info: zcat to pipe: $!\n";
		return undef;
	}
	my %acronomicon;
	local $_ = '';
	do {$_ = <$fh>} until !defined $_ or /^\*\*\*/;
	local $/ = '';
	while (<$fh>) {
		last if /^Examples:/;
		my ($acronym, @explanation) = split /[ \t\r]*?\n/;
		next unless $acronym =~ m/^[[:upper:][:digit:]]+$/;
		do {s/^\s*//; s/\s*$//} for @explanation;
		$acronomicon{$acronym} = []
			unless exists $acronomicon{$acronym};
		push @{$acronomicon{$acronym}}, join ' ', @explanation;
	}
	$/ = undef;
	$_ = <$fh>;
	close $fh;
	print "... done parsing\n";
	$self->{acronomicon} = \%acronomicon;
	bless $self, $class;
}

sub get_id {
	my $class = shift;
	return "Vera";
}

sub get_msg_handlers {
	my $class = shift;
	return '!vera' => {qw(action ask_vera restricted 0 level 0)};
}

sub ask_vera {
	my $self = shift;
	my $event = pop @_;
	my $key = uc shift;
	my $vera_info = $self->{core}->{config}->{vera_info};
	my $acro = $self->{acronomicon};

RETRY:
	if (exists $acro->{$key}) {
		local $_;
		$self->{core}->queue($event, "$key - $_") for @{$acro->{$key}};
	} else {
		goto RETRY if $key =~ s/[[:digit:]]+$//;
		$self->{core}->queue($event, "Vera ei tea sellest hkagi")
	}
}

1; # vim: fileencoding=latin-1
