-- Make sure you have a backup of your old database before attempting
-- the upgrade

-- create history table
 CREATE TABLE `history` (
  `term` varchar(60) NOT NULL default '',
  `story` text,
  `counter` int(10) unsigned default '0',
  `nick` varchar(50) NOT NULL default '',
  `userhost` varchar(200) NOT NULL default '',
  `changed` datetime NOT NULL default '0000-00-00 00:00:00',
  `history` int(11) default '1',
  `operation` smallint(6) default '1',
  `id` bigint(20) unsigned NOT NULL auto_increment,
  PRIMARY KEY  (`id`),
  KEY `term` (`term`)
) TYPE=MyISAM;

-- nuke "deleted" records from terms table
DELETE FROM terms WHERE operation > 100;

-- copy everything from terms to history

INSERT INTO history (term,story,counter,nick,userhost,changed,history,operation) SELECT term,story,counter,nick,userhost,changed,history,operation FROM terms;

-- create temporary table for terms table conversion
CREATE TEMPORARY TABLE `tmp_termconvert` (
  `term` varchar(60) NOT NULL default '',
  `story` text,
  `history` int,
  `counter` int(10) unsigned default '0',
  `nick` varchar(50) NOT NULL default '',
  `userhost` varchar(200) NOT NULL default '',
  `changed` datetime NOT NULL default '0000-00-00 00:00:00',
  `id` bigint(20) unsigned NOT NULL auto_increment,
  PRIMARY KEY  (`id`),
  KEY `term` (`term`)
) TYPE=MyISAM;

-- copy one record for each term from the terms table
INSERT INTO tmp_termconvert (term,history) SELECT term,MAX(history) FROM history GROUP BY term;

-- empty terms table 
DELETE FROM terms;

-- drop unnecessary fields
ALTER TABLE terms DROP KEY term;
ALTER TABLE terms DROP history;
ALTER TABLE terms DROP operation;
ALTER TABLE terms ADD id BIGINT UNSIGNED NOT NULL AUTO_INCREMENT PRIMARY KEY;
ALTER TABLE terms CHANGE nick nick char(50);

-- now do the join query thing to get the latest data for each
-- term into the tmp table
INSERT INTO terms (term,story,counter,nick,userhost,changed) 
SELECT history.term,history.story,history.counter,history.nick,history.userhost,history.changed FROM tmp_termconvert,history
WHERE tmp_termconvert.term = history.term AND tmp_termconvert.history = history.history;

-- drop the temp table
-- DROP TABLE tmp_termconvert;

-- and we should be done.
-- Have a nice day!



